// Exported functions
module.exports = {
    site_info: function (req) {

        var ret = {
            "site_name": "Website Template",
            "site_url": "https://website.template",
            "site_title": "Title of website",
        };

        if ("SITE_NAME" in process.env) {
            ret.name = process.env.SITE_NAME;
        }
        if ("SITE_URL" in process.env) {
            ret.url = process.env.SITE_URL;
        }
        if ("SITE_TITLE" in process.env) {
            ret.title = process.env.SITE_TITLE;
        }

        return ret;
    },
    site_ga_stub: function (req) {
        // Tracking disabled by DNT
        if (("dnt" in req.headers) && (req.headers["dnt"] == 1)) {
            return `<!-- DNT - Tracking disabled -->`;
        }

        // Google Analytics stub
        if ("SITE_GA_ID" in process.env) {
            return `
<!-- Google Analytics stuff -->
<script type="text/javascript">
var gaJsHost = (("https:" == document.location.protocol) ? "https://ssl." : "http://www.");
document.write(unescape("%3Cscript src='" + gaJsHost + "google-analytics.com/ga.js' type='text/javascript'%3E%3C/script%3E"));
</script>
<script type="text/javascript">
try {
var pageTracker = _gat._getTracker("${process.env.SITE_GA_ID}");
pageTracker._trackPageview();
} catch(err) {}</script>`;
        }

        // Default - no tracking information provided
        return "<!-- No GA Tracking -->";

    }
}
